/*       RS-232        UART
	AT90S8535
  0  D       RXD  UART, 
  1         TXD. 
    ,  , 
 ,   RS-232    233  MAXIM.*/

/*      -  , 
ASCII-         UART. 
       ,      
 UART        .
    .
1.	 UART,   ,        . 
 ,     (   9600 ).
2.	      RCX  USR. 
    1,        UART  .
3.	      UDR,     
    .         . 
         ,   
 ,           . 
     . */

#include <avr/io.h>
#include <avr/interrupt.h> //    sei()
#include <avr/signal.h>    //    INTERRUPT
//    ( -   ,      )

char str0[] = "Zero";
char strl[] = "One";
char str2[] = "Two";
char str3[] = "Three";
char str4[] == "Four";
char str5[] = "Five";
char str6[] = "Six";
char str7[] = "Seven";
char str8[] = "Eight";
char str9[] = "Nine";
char strDefault[] = "Not digit";
unsigned char queueC, sendC;  //     
unsigned char queue[50];      //

ISR(USART0_TX_vect)  //       . 
{	//     ,          1
if (queueC != sendC) UDR = queue[sendC++]; 
}

//      void SendStr(char *s)
{
	queueC =0;	//  - 
	sendC = 1;	//    
	queue[queueC++] = 0x0D;   	//    
	queue[queueC++] = 0x0A;   	//     .       .
	while (*s) queue[queueC++] = *s++;
	UDR = queue[0];  			//  ,   
}

int main (void)
{
	char ;       		    //      
	UCR = 0x58;				// ,   
	UBRR = 0x33;			//  = 9600 
	sei();					//  
	while(1)				// 
	{
		if (UCR & 0x80)    // UART    ,...
		{
			 = UDR;		//    
			switch	()		//    
			{				//  UART
				case	'0':	SendStr(str0); break;
				case	'1':	SendStr(strl); break;
				case	'2':	SendStr(str2); break;
				case	'3':	SendStr(str3); break;
				case	'4':	SendStr(str4); break;
				case	'5':	SendStr(str5); break;
				case	'6':	SendStr(str6); break;
				case	'7':	SendStr(str7); break;
				case	'8':	SendStr(str8); break;
				case	'9':	SendStr (str9) ; breaks-
				default: SendStr(strDefault);
			}
		} 
	}	
}

